#lang racket

(require "mauxb.rkt")

;;;; 6. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 22.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - univerzálna funkcia pre čiastočne rekurzívne funkcie,
;;;; - efektívne operácie na primitívne rekurzívnych indexoch.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 3
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 3.4.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Primitívne rekurzívne funkcie.

;;; Sekcia. Univerzálna funkcia pre primitívne rekurzívne funkcie.

;;; Podsekcia. Aritmetizácia primitívne rekurzívnych funkčných symbolov.

;; [Lisp] Pozri modul v súbore mauxb.rkt.

;;; Podsekcia. Interpreter primitívne rekurzívnych funkčných symbolov.

;; [Lisp] Pozri modul v súbore mauxb.rkt.

;;; Podsekcia. Primitívne rekurzívne indexy.

;; Definícia. Ak platí predikát p.r.-function-symbol?(n,e), tak vravíme, že
;; číslo e je dobre vytvorený primitívne rekurzívny index n-árnej primitívne
;; rekurzívnej funkcie.

;;; Podsekcia. Efektívne operácie na primitívne rekurzívnych indexoch.

;; Úloha. Zostrojte program pre funkciu xc1(m) takú, že platí:
;;   p.r.-function-symbol?(1,xc1(m))
;;   interpreter(xc1(m),x) = m

(define (xc1 m) ...)

;; (PRFS? (xc1 5))
;; (p.r.-function-symbol? 1 (xc1 5))
;; (query (λ (x) (interpreter (xc1 5) x)) 0 10)

;; (query (λ (m) (PRFS? (xc1 m))) 0 10)
;; (query (λ (m) (p.r.-function-symbol? 1 (xc1 m))) 0 10)

;; (prémia 1 bod)
;; Úloha. Zostrojte program pre funkciu xc2(n,m) takú, že platí:
;;   p.r.-function-symbol?(n,xc2(n,m))
;;   interpreter(xc2(n,m),x1,...,xn) = m

(define (xc2 n m) ...)

;; (PRFS? (xc2 3 5))
;; (p.r.-function-symbol? 3 (xc2 3 5))
;; (query (λ (x) (interpreter (xc2 3 5) (cons x (cons x x)))) 0 10)

;; (query (λ (n) (PRFS? (xc2 n 5))) 1 10)
;; (query (λ (n) (p.r.-function-symbol? n (xc2 n 5))) 1 10)

;; Úloha. Zostrojte program pre funkciu xiter(e) takú, že platí:
;;   p.r.-function-symbol?(1,e) → p.r.-function-symbol?(2,xiter(e))
;;   interpreter(xiter(e),cons(0,x)) = x
;;   interpreter(xiter(e),cons(n+1,x)) = interpreter(e,interpreter(xiter(e),cons(n,x)))

(define (xiter e) ...)

;; (prémia 1 bod)
;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre sčítanie
;; pomocou funkcie xiter.

(define ⌜+⌝ ...)

;; (PRFS? ⌜+⌝)
;; (p.r.-function-symbol? 2 ⌜+⌝)
;; (query (λ (x) (interpreter ⌜+⌝ (cons x 5))) 0 10)

;; Úloha. Zostrojte program pre funkciu xparam(e,x) takú, že platí:
;;   p.r.-function-symbol?(2,e) → p.r.-function-symbol?(1,xparam(e,x))
;;   interpreter(xparam(e,x),y) = interpreter(e,cons(x,y))

(define (xparam e x) ...)

;; (PRFS? (xparam ⌜+⌝ 5))
;; (p.r.-function-symbol? 1 (xparam ⌜+⌝ 5))
;; (query (λ (x) (interpreter (xparam ⌜+⌝ 5) x)) 0 10)

;; (prémia 1 bod)
;; Úloha. Zostrojte program pre funkciu xsmn-2-3(e,x1,x2) takú, že platí:
;;   p.r.-function-symbol?(5,e) → p.r.-function-symbol?(3,xsmn-3-5(e,x1,x2))
;;   interpreter(xsmn-2-3(e,x1,x2),cons(y1,cons(y2,y3)) = interpreter(e,cons(x1,cons(x2,cons(y1,cons(y2,y3)))))

(define (xsmn-2-3 e x1 x2) ...)

;; (query (λ (n) (PRFS? (xsmn-2-3 (Ix 5 1) n n))) 0 10)
;; (query (λ (n) (p.r.-function-symbol? 3 (xsmn-2-3 (Ix 5 1) n n))) 0 10)
